MCP Tools Reference: ces.googleapis.com

Tool: create_agent

Creates a new agent in the given app.

The following sample demonstrate how to use curl to invoke the create_agent MCP tool.

Curl Request
                  
curl --location 'https://ces.[REGION].rep.googleapis.com/mcp' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "create_agent",
    "arguments": {
      // provide these details according to the tool's MCP specification
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'
                

Input Schema

Request message for AgentService.CreateAgent.

CreateAgentRequest

JSON representation
{
  "parent": string,
  "agentId": string,
  "agent": {
    object (Agent)
  }
}
Fields
parent

string

Required. The resource name of the app to create an agent in.

agentId

string

Optional. The ID to use for the agent, which will become the final component of the agent's resource name. If not provided, a unique ID will be automatically assigned for the agent.

agent

object (Agent)

Required. The agent to create.

Agent

JSON representation
{
  "name": string,
  "displayName": string,
  "description": string,
  "modelSettings": {
    object (ModelSettings)
  },
  "instruction": string,
  "tools": [
    string
  ],
  "childAgents": [
    string
  ],
  "beforeAgentCallbacks": [
    {
      object (Callback)
    }
  ],
  "afterAgentCallbacks": [
    {
      object (Callback)
    }
  ],
  "beforeModelCallbacks": [
    {
      object (Callback)
    }
  ],
  "afterModelCallbacks": [
    {
      object (Callback)
    }
  ],
  "beforeToolCallbacks": [
    {
      object (Callback)
    }
  ],
  "afterToolCallbacks": [
    {
      object (Callback)
    }
  ],
  "createTime": string,
  "updateTime": string,
  "guardrails": [
    string
  ],
  "etag": string,
  "toolsets": [
    {
      object (AgentToolset)
    }
  ],
  "generatedSummary": string,
  "transferRules": [
    {
      object (TransferRule)
    }
  ],

  // Union field agent_type can be only one of the following:
  "llmAgent": {
    object (LlmAgent)
  },
  "remoteDialogflowAgent": {
    object (RemoteDialogflowAgent)
  }
  // End of list of possible types for union field agent_type.
}
Fields
name

string

Identifier. The unique identifier of the agent. Format: projects/{project}/locations/{location}/apps/{app}/agents/{agent}

displayName

string

Required. Display name of the agent.

description

string

Optional. Human-readable description of the agent.

modelSettings

object (ModelSettings)

Optional. Configurations for the LLM model.

instruction

string

Optional. Instructions for the LLM model to guide the agent's behavior.

tools[]

string

Optional. List of available tools for the agent. Format: projects/{project}/locations/{location}/apps/{app}/tools/{tool}

childAgents[]

string

Optional. List of child agents in the agent tree. Format: projects/{project}/locations/{location}/apps/{app}/agents/{agent}

beforeAgentCallbacks[]

object (Callback)

Optional. The callbacks to execute before the agent is called. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

afterAgentCallbacks[]

object (Callback)

Optional. The callbacks to execute after the agent is called. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

beforeModelCallbacks[]

object (Callback)

Optional. The callbacks to execute before the model is called. If there are multiple calls to the model, the callback will be executed multiple times. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

afterModelCallbacks[]

object (Callback)

Optional. The callbacks to execute after the model is called. If there are multiple calls to the model, the callback will be executed multiple times. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

beforeToolCallbacks[]

object (Callback)

Optional. The callbacks to execute before the tool is invoked. If there are multiple tool invocations, the callback will be executed multiple times. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

afterToolCallbacks[]

object (Callback)

Optional. The callbacks to execute after the tool is invoked. If there are multiple tool invocations, the callback will be executed multiple times. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

createTime

string (Timestamp format)

Output only. Timestamp when the agent was created.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

updateTime

string (Timestamp format)

Output only. Timestamp when the agent was last updated.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

guardrails[]

string

Optional. List of guardrails for the agent. Format: projects/{project}/locations/{location}/apps/{app}/guardrails/{guardrail}

etag

string

Etag used to ensure the object hasn't changed during a read-modify-write operation. If the etag is empty, the update will overwrite any concurrent changes.

toolsets[]

object (AgentToolset)

Optional. List of toolsets for the agent.

generatedSummary

string

Output only. If the agent is generated by the LLM assistant, this field contains a descriptive summary of the generation.

transferRules[]

object (TransferRule)

Optional. Agent transfer rules. If multiple rules match, the first one in the list will be used.

Union field agent_type. The type of agent. agent_type can be only one of the following:
llmAgent

object (LlmAgent)

Optional. The default agent type.

remoteDialogflowAgent

object (RemoteDialogflowAgent)

Optional. The remote Dialogflow agent to be used for the agent execution. If this field is set, all other agent level properties will be ignored.

Note: If the Dialogflow agent is in a different project from the app, you should grant roles/dialogflow.client to the CES service agent service-<PROJECT-NUMBER>@gcp-sa-ces.iam.gserviceaccount.com.

RemoteDialogflowAgent

JSON representation
{
  "agent": string,
  "flowId": string,
  "environmentId": string,
  "inputVariableMapping": {
    string: string,
    ...
  },
  "outputVariableMapping": {
    string: string,
    ...
  },
  "respectResponseInterruptionSettings": boolean
}
Fields
agent

string

Required. The Dialogflow agent resource name. Format: projects/{project}/locations/{location}/agents/{agent}

flowId

string

Optional. The flow ID of the flow in the Dialogflow agent.

environmentId

string

Optional. The environment ID of the Dialogflow agent to be used for the agent execution. If not specified, the draft environment will be used.

inputVariableMapping

map (key: string, value: string)

Optional. The mapping of the app variables names to the Dialogflow session parameters names to be sent to the Dialogflow agent as input.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

outputVariableMapping

map (key: string, value: string)

Optional. The mapping of the Dialogflow session parameters names to the app variables names to be sent back to the CES agent after the Dialogflow agent execution ends.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

respectResponseInterruptionSettings

boolean

Optional. Indicates whether to respect the message-level interruption settings configured in the Dialogflow agent.

  • If false: all response messages from the Dialogflow agent follow the app-level barge-in settings.
  • If true: only response messages with allow_playback_interruption set to true will be interruptable, all other messages follow the app-level barge-in settings.

InputVariableMappingEntry

JSON representation
{
  "key": string,
  "value": string
}
Fields
key

string

value

string

OutputVariableMappingEntry

JSON representation
{
  "key": string,
  "value": string
}
Fields
key

string

value

string

ModelSettings

JSON representation
{
  "model": string,

  // Union field _temperature can be only one of the following:
  "temperature": number
  // End of list of possible types for union field _temperature.
}
Fields
model

string

Optional. The LLM model that the agent should use. If not set, the agent will inherit the model from its parent agent.

Union field _temperature.

_temperature can be only one of the following:

temperature

number

Optional. If set, this temperature will be used for the LLM model. Temperature controls the randomness of the model's responses. Lower temperatures produce responses that are more predictable. Higher temperatures produce responses that are more creative.

Callback

JSON representation
{
  "description": string,
  "disabled": boolean,
  "proactiveExecutionEnabled": boolean,

  // Union field callback can be only one of the following:
  "pythonCode": string
  // End of list of possible types for union field callback.
}
Fields
description

string

Optional. Human-readable description of the callback.

disabled

boolean

Optional. Whether the callback is disabled. Disabled callbacks are ignored by the agent.

proactiveExecutionEnabled

boolean

Optional. If enabled, the callback will also be executed on intermediate model outputs. This setting only affects after model callback. ENABLE WITH CAUTION. Typically after model callback only needs to be executed after receiving all model responses. Enabling proactive execution may have negative implication on the execution cost and latency, and should only be enabled in rare situations.

Union field callback. The callback to execute. callback can be only one of the following:
pythonCode

string

Required. The python code to execute for the callback.

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

AgentToolset

JSON representation
{
  "toolset": string,
  "toolIds": [
    string
  ]
}
Fields
toolset

string

Required. The resource name of the toolset. Format: projects/{project}/locations/{location}/apps/{app}/toolsets/{toolset}

toolIds[]

string

Optional. The tools IDs to filter the toolset.

TransferRule

JSON representation
{
  "childAgent": string,
  "direction": enum (Direction),

  // Union field rule_type can be only one of the following:
  "deterministicTransfer": {
    object (DeterministicTransfer)
  },
  "disablePlannerTransfer": {
    object (DisablePlannerTransfer)
  }
  // End of list of possible types for union field rule_type.
}
Fields
childAgent

string

Required. The resource name of the child agent the rule applies to. Format: projects/{project}/locations/{location}/apps/{app}/agents/{agent}

direction

enum (Direction)

Required. The direction of the transfer.

Union field rule_type. The rule type. rule_type can be only one of the following:
deterministicTransfer

object (DeterministicTransfer)

Optional. A rule that immediately transfers to the target agent when the condition is met.

disablePlannerTransfer

object (DisablePlannerTransfer)

Optional. Rule that prevents the planner from transferring to the target agent.

DeterministicTransfer

JSON representation
{

  // Union field condition_type can be only one of the following:
  "expressionCondition": {
    object (ExpressionCondition)
  },
  "pythonCodeCondition": {
    object (PythonCodeCondition)
  }
  // End of list of possible types for union field condition_type.
}
Fields
Union field condition_type. The condition to evaluate. condition_type can be only one of the following:
expressionCondition

object (ExpressionCondition)

Optional. A rule that evaluates a session state condition. If the condition evaluates to true, the transfer occurs.

pythonCodeCondition

object (PythonCodeCondition)

Optional. A rule that uses Python code block to evaluate the conditions. If the condition evaluates to true, the transfer occurs.

ExpressionCondition

JSON representation
{
  "expression": string
}
Fields
expression

string

Required. The string representation of cloud.api.Expression condition.

PythonCodeCondition

JSON representation
{
  "pythonCode": string
}
Fields
pythonCode

string

Required. The python code to execute.

DisablePlannerTransfer

JSON representation
{
  "expressionCondition": {
    object (ExpressionCondition)
  }
}
Fields
expressionCondition

object (ExpressionCondition)

Required. If the condition evaluates to true, planner will not be allowed to transfer to the target agent.

Output Schema

An agent acts as the fundamental building block that provides instructions to the Large Language Model (LLM) for executing specific tasks.

Agent

JSON representation
{
  "name": string,
  "displayName": string,
  "description": string,
  "modelSettings": {
    object (ModelSettings)
  },
  "instruction": string,
  "tools": [
    string
  ],
  "childAgents": [
    string
  ],
  "beforeAgentCallbacks": [
    {
      object (Callback)
    }
  ],
  "afterAgentCallbacks": [
    {
      object (Callback)
    }
  ],
  "beforeModelCallbacks": [
    {
      object (Callback)
    }
  ],
  "afterModelCallbacks": [
    {
      object (Callback)
    }
  ],
  "beforeToolCallbacks": [
    {
      object (Callback)
    }
  ],
  "afterToolCallbacks": [
    {
      object (Callback)
    }
  ],
  "createTime": string,
  "updateTime": string,
  "guardrails": [
    string
  ],
  "etag": string,
  "toolsets": [
    {
      object (AgentToolset)
    }
  ],
  "generatedSummary": string,
  "transferRules": [
    {
      object (TransferRule)
    }
  ],

  // Union field agent_type can be only one of the following:
  "llmAgent": {
    object (LlmAgent)
  },
  "remoteDialogflowAgent": {
    object (RemoteDialogflowAgent)
  }
  // End of list of possible types for union field agent_type.
}
Fields
name

string

Identifier. The unique identifier of the agent. Format: projects/{project}/locations/{location}/apps/{app}/agents/{agent}

displayName

string

Required. Display name of the agent.

description

string

Optional. Human-readable description of the agent.

modelSettings

object (ModelSettings)

Optional. Configurations for the LLM model.

instruction

string

Optional. Instructions for the LLM model to guide the agent's behavior.

tools[]

string

Optional. List of available tools for the agent. Format: projects/{project}/locations/{location}/apps/{app}/tools/{tool}

childAgents[]

string

Optional. List of child agents in the agent tree. Format: projects/{project}/locations/{location}/apps/{app}/agents/{agent}

beforeAgentCallbacks[]

object (Callback)

Optional. The callbacks to execute before the agent is called. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

afterAgentCallbacks[]

object (Callback)

Optional. The callbacks to execute after the agent is called. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

beforeModelCallbacks[]

object (Callback)

Optional. The callbacks to execute before the model is called. If there are multiple calls to the model, the callback will be executed multiple times. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

afterModelCallbacks[]

object (Callback)

Optional. The callbacks to execute after the model is called. If there are multiple calls to the model, the callback will be executed multiple times. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

beforeToolCallbacks[]

object (Callback)

Optional. The callbacks to execute before the tool is invoked. If there are multiple tool invocations, the callback will be executed multiple times. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

afterToolCallbacks[]

object (Callback)

Optional. The callbacks to execute after the tool is invoked. If there are multiple tool invocations, the callback will be executed multiple times. The provided callbacks are executed sequentially in the exact order they are given in the list. If a callback returns an overridden response, execution stops and any remaining callbacks are skipped.

createTime

string (Timestamp format)

Output only. Timestamp when the agent was created.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

updateTime

string (Timestamp format)

Output only. Timestamp when the agent was last updated.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

guardrails[]

string

Optional. List of guardrails for the agent. Format: projects/{project}/locations/{location}/apps/{app}/guardrails/{guardrail}

etag

string

Etag used to ensure the object hasn't changed during a read-modify-write operation. If the etag is empty, the update will overwrite any concurrent changes.

toolsets[]

object (AgentToolset)

Optional. List of toolsets for the agent.

generatedSummary

string

Output only. If the agent is generated by the LLM assistant, this field contains a descriptive summary of the generation.

transferRules[]

object (TransferRule)

Optional. Agent transfer rules. If multiple rules match, the first one in the list will be used.

Union field agent_type. The type of agent. agent_type can be only one of the following:
llmAgent

object (LlmAgent)

Optional. The default agent type.

remoteDialogflowAgent

object (RemoteDialogflowAgent)

Optional. The remote Dialogflow agent to be used for the agent execution. If this field is set, all other agent level properties will be ignored.

Note: If the Dialogflow agent is in a different project from the app, you should grant roles/dialogflow.client to the CES service agent service-<PROJECT-NUMBER>@gcp-sa-ces.iam.gserviceaccount.com.

RemoteDialogflowAgent

JSON representation
{
  "agent": string,
  "flowId": string,
  "environmentId": string,
  "inputVariableMapping": {
    string: string,
    ...
  },
  "outputVariableMapping": {
    string: string,
    ...
  },
  "respectResponseInterruptionSettings": boolean
}
Fields
agent

string

Required. The Dialogflow agent resource name. Format: projects/{project}/locations/{location}/agents/{agent}

flowId

string

Optional. The flow ID of the flow in the Dialogflow agent.

environmentId

string

Optional. The environment ID of the Dialogflow agent to be used for the agent execution. If not specified, the draft environment will be used.

inputVariableMapping

map (key: string, value: string)

Optional. The mapping of the app variables names to the Dialogflow session parameters names to be sent to the Dialogflow agent as input.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

outputVariableMapping

map (key: string, value: string)

Optional. The mapping of the Dialogflow session parameters names to the app variables names to be sent back to the CES agent after the Dialogflow agent execution ends.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

respectResponseInterruptionSettings

boolean

Optional. Indicates whether to respect the message-level interruption settings configured in the Dialogflow agent.

  • If false: all response messages from the Dialogflow agent follow the app-level barge-in settings.
  • If true: only response messages with allow_playback_interruption set to true will be interruptable, all other messages follow the app-level barge-in settings.

InputVariableMappingEntry

JSON representation
{
  "key": string,
  "value": string
}
Fields
key

string

value

string

OutputVariableMappingEntry

JSON representation
{
  "key": string,
  "value": string
}
Fields
key

string

value

string

ModelSettings

JSON representation
{
  "model": string,

  // Union field _temperature can be only one of the following:
  "temperature": number
  // End of list of possible types for union field _temperature.
}
Fields
model

string

Optional. The LLM model that the agent should use. If not set, the agent will inherit the model from its parent agent.

Union field _temperature.

_temperature can be only one of the following:

temperature

number

Optional. If set, this temperature will be used for the LLM model. Temperature controls the randomness of the model's responses. Lower temperatures produce responses that are more predictable. Higher temperatures produce responses that are more creative.

Callback

JSON representation
{
  "description": string,
  "disabled": boolean,
  "proactiveExecutionEnabled": boolean,

  // Union field callback can be only one of the following:
  "pythonCode": string
  // End of list of possible types for union field callback.
}
Fields
description

string

Optional. Human-readable description of the callback.

disabled

boolean

Optional. Whether the callback is disabled. Disabled callbacks are ignored by the agent.

proactiveExecutionEnabled

boolean

Optional. If enabled, the callback will also be executed on intermediate model outputs. This setting only affects after model callback. ENABLE WITH CAUTION. Typically after model callback only needs to be executed after receiving all model responses. Enabling proactive execution may have negative implication on the execution cost and latency, and should only be enabled in rare situations.

Union field callback. The callback to execute. callback can be only one of the following:
pythonCode

string

Required. The python code to execute for the callback.

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

AgentToolset

JSON representation
{
  "toolset": string,
  "toolIds": [
    string
  ]
}
Fields
toolset

string

Required. The resource name of the toolset. Format: projects/{project}/locations/{location}/apps/{app}/toolsets/{toolset}

toolIds[]

string

Optional. The tools IDs to filter the toolset.

TransferRule

JSON representation
{
  "childAgent": string,
  "direction": enum (Direction),

  // Union field rule_type can be only one of the following:
  "deterministicTransfer": {
    object (DeterministicTransfer)
  },
  "disablePlannerTransfer": {
    object (DisablePlannerTransfer)
  }
  // End of list of possible types for union field rule_type.
}
Fields
childAgent

string

Required. The resource name of the child agent the rule applies to. Format: projects/{project}/locations/{location}/apps/{app}/agents/{agent}

direction

enum (Direction)

Required. The direction of the transfer.

Union field rule_type. The rule type. rule_type can be only one of the following:
deterministicTransfer

object (DeterministicTransfer)

Optional. A rule that immediately transfers to the target agent when the condition is met.

disablePlannerTransfer

object (DisablePlannerTransfer)

Optional. Rule that prevents the planner from transferring to the target agent.

DeterministicTransfer

JSON representation
{

  // Union field condition_type can be only one of the following:
  "expressionCondition": {
    object (ExpressionCondition)
  },
  "pythonCodeCondition": {
    object (PythonCodeCondition)
  }
  // End of list of possible types for union field condition_type.
}
Fields
Union field condition_type. The condition to evaluate. condition_type can be only one of the following:
expressionCondition

object (ExpressionCondition)

Optional. A rule that evaluates a session state condition. If the condition evaluates to true, the transfer occurs.

pythonCodeCondition

object (PythonCodeCondition)

Optional. A rule that uses Python code block to evaluate the conditions. If the condition evaluates to true, the transfer occurs.

ExpressionCondition

JSON representation
{
  "expression": string
}
Fields
expression

string

Required. The string representation of cloud.api.Expression condition.

PythonCodeCondition

JSON representation
{
  "pythonCode": string
}
Fields
pythonCode

string

Required. The python code to execute.

DisablePlannerTransfer

JSON representation
{
  "expressionCondition": {
    object (ExpressionCondition)
  }
}
Fields
expressionCondition

object (ExpressionCondition)

Required. If the condition evaluates to true, planner will not be allowed to transfer to the target agent.

Tool Annotations

Destructive Hint: ✅ | Idempotent Hint: ❌ | Read Only Hint: ❌ | Open World Hint: ❌